"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = useOverlayOffset;

var _react = require("react");

var _hasClass = _interopRequireDefault(require("dom-helpers/hasClass"));

var _ThemeProvider = require("./ThemeProvider");

var _Popover = _interopRequireDefault(require("./Popover"));

// This is meant for internal use.
// This applies a custom offset to the overlay if it's a popover.
function useOverlayOffset() {
  var overlayRef = (0, _react.useRef)(null);
  var popoverClass = (0, _ThemeProvider.useBootstrapPrefix)(undefined, 'popover');
  var offset = (0, _react.useMemo)(function () {
    return {
      name: 'offset',
      options: {
        offset: function offset() {
          if (overlayRef.current && (0, _hasClass.default)(overlayRef.current, popoverClass)) {
            return _Popover.default.POPPER_OFFSET;
          }

          return [0, 0];
        }
      }
    };
  }, [popoverClass]);
  return [overlayRef, [offset]];
}

module.exports = exports.default;