import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import classNames from 'classnames';
import * as React from 'react';
import { useContext } from 'react';
import { useBootstrapPrefix } from './ThemeProvider';
import Collapse from './Collapse';
import AccordionContext from './AccordionContext';
import { jsx as _jsx } from "react/jsx-runtime";
var AccordionCollapse = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var bsPrefix = _ref.bsPrefix,
      className = _ref.className,
      children = _ref.children,
      eventKey = _ref.eventKey,
      props = _objectWithoutPropertiesLoose(_ref, ["bsPrefix", "className", "children", "eventKey"]);

  var _useContext = useContext(AccordionContext),
      activeEventKey = _useContext.activeEventKey;

  bsPrefix = useBootstrapPrefix(bsPrefix, 'accordion-collapse');
  return /*#__PURE__*/_jsx(Collapse, _extends({
    ref: ref,
    in: activeEventKey === eventKey
  }, props, {
    className: classNames(className, bsPrefix),
    children: /*#__PURE__*/_jsx("div", {
      children: React.Children.only(children)
    })
  }));
});
AccordionCollapse.displayName = 'AccordionCollapse';
export default AccordionCollapse;