import { useMemo, useRef } from 'react';
import hasClass from 'dom-helpers/hasClass';
import { useBootstrapPrefix } from './ThemeProvider';
import Popover from './Popover'; // This is meant for internal use.
// This applies a custom offset to the overlay if it's a popover.

export default function useOverlayOffset() {
  var overlayRef = useRef(null);
  var popoverClass = useBootstrapPrefix(undefined, 'popover');
  var offset = useMemo(function () {
    return {
      name: 'offset',
      options: {
        offset: function offset() {
          if (overlayRef.current && hasClass(overlayRef.current, popoverClass)) {
            return Popover.POPPER_OFFSET;
          }

          return [0, 0];
        }
      }
    };
  }, [popoverClass]);
  return [overlayRef, [offset]];
}